package com.zhibao.crm.utils;

import com.qcloud.cos.utils.Md5Utils;
import com.zhibao.crm.ocr.Base64Util;
import com.zhibao.crm.utils.RSAUtils;
import java.net.InetAddress;
import java.net.URLEncoder;
import java.net.UnknownHostException;
import javax.servlet.http.HttpServletRequest;

public class IPUtils {

   public static String getIpAddress(HttpServletRequest request) {
      String ip = request.getHeader("x-forwarded-for");
      if(ip == null || ip.length() == 0 || "unknown".equalsIgnoreCase(ip)) {
         ip = request.getHeader("Proxy-Client-IP");
      }

      if(ip == null || ip.length() == 0 || "unknown".equalsIgnoreCase(ip)) {
         ip = request.getHeader("WL-Proxy-Client-IP");
      }

      if(ip == null || ip.length() == 0 || "unknown".equalsIgnoreCase(ip)) {
         ip = request.getRemoteAddr();
      }

      if(ip == null || ip.length() == 0 || "unknown".equalsIgnoreCase(ip)) {
         ip = request.getHeader("http_client_ip");
      }

      if(ip == null || ip.length() == 0 || "unknown".equalsIgnoreCase(ip)) {
         ip = request.getHeader("HTTP_X_FORWARDED_FOR");
      }

      if(ip != null && ip.indexOf(",") != -1) {
         ip = ip.substring(ip.lastIndexOf(",") + 1, ip.length()).trim();
      }

      if("0:0:0:0:0:0:0:1".equals(ip)) {
         ip = "127.0.0.1";
      }

      return ip;
   }

   public static String getLocalAddress() {
      try {
         InetAddress address = InetAddress.getLocalHost();
         return address.getHostAddress();
      } catch (UnknownHostException var2) {
         var2.printStackTrace();
         return "";
      }
   }

   public static String replaceDomainAndPort(String domain, String port, String url) {
      String url_bak = "";
      if(url.indexOf("//") != -1) {
         String[] splitTemp = url.split("//");
         url_bak = splitTemp[0] + "//";
         if(port != null) {
            url_bak = url_bak + domain + ":" + port;
         }

         if(splitTemp.length >= 1 && splitTemp[1].indexOf("/") != -1) {
            String[] urlTemp2 = splitTemp[1].split("/");
            if(urlTemp2.length > 1) {
               for(int i = 1; i < urlTemp2.length; ++i) {
                  url_bak = url_bak + "/" + urlTemp2[i];
               }
            }

            System.out.println("url_bak:" + url_bak);
         } else {
            System.out.println("url_bak:" + url_bak);
         }
      }

      return url_bak;
   }

   public static void main(String[] args) throws Exception {
      String aa = "{\"insuredMobile\":\"*******7660\",\"endDate\":\"2024-02-06\",\"insuredIdType\":1,\"insuranceCompany\":\"富邦国际(厦门)保险经纪有限公司\",\"startDate\":\"2023-02-06\"}";
      String signStr = "bxChannel=fubangjingjifbb&timestamp=1675679060109::123456";
      System.out.println(Md5Utils.md5Hex(signStr));
      byte[] bs = aa.getBytes();
      System.out.println(RSAUtils.encrypt("MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQCFg/mcv3IDE0TfGpXpuriOnKwqSmLAnyQV9uqWodxWwKdZzENRDjLhx5uHukRCGHnhHybTSGVV1FejCLXX/MejBn8ncAbPpIqx8dYHi9OVS8rfcJiLvbz+522WoJbZQzWCuIG8xBUC8wi945HKbwtQPWEPmqUNXjq8kY2UJsMyKQIDAQAB", Base64Util.encode(bs)));
      String clintId = URLEncoder.encode(RSAUtils.encrypt("MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQCFg/mcv3IDE0TfGpXpuriOnKwqSmLAnyQV9uqWodxWwKdZzENRDjLhx5uHukRCGHnhHybTSGVV1FejCLXX/MejBn8ncAbPpIqx8dYHi9OVS8rfcJiLvbz+522WoJbZQzWCuIG8xBUC8wi945HKbwtQPWEPmqUNXjq8kY2UJsMyKQIDAQAB", "FB1070715901001248769"));
      System.out.println(clintId);
      System.out.println(Md5Utils.md5Hex("bxChannel=fubangjingjifbb&clientId=" + clintId + "&timestamp=1675235352915123456"));
      System.out.println(URLEncoder.encode("bxChannel=fubangjingjifbb&clientId=" + clintId + "&timestamp=1675235352915"));
   }
}
